@ECHO OFF
PUSHD "%~dp0"

IF "%PROCESSOR_ARCHITECTURE%"=="AMD64" (set "os_arch=x86_64")
IF DEFINED PROCESSOR_ARCHITEW6432 (set "os_arch=x86_64")

if exist "%~dp0\winws.exe" (
goto :ZapretStart
) else (
if %os_arch%==x86_64 (
goto :ProgDownload64 )
else (
goto :ProgDownload32 )
)
goto :EOF

:ProgDownload64
echo Start downloading cygwin1.dll from Zapret GitHub repo (may take some time).....
bitsadmin /transfer progdwnl https://github.com/bol-van/zapret/blob/master/binaries/win64/zapret-winws/cygwin1.dll?raw=true "%~dp0\cygwin1.dll" > nul
echo Downloading cygwin1.dll..... Completed!
echo Start downloading WinDivert.dll from Zapret GitHub repo.....
bitsadmin /transfer progdwnl https://github.com/bol-van/zapret/blob/master/binaries/win64/zapret-winws/WinDivert.dll?raw=true "%~dp0\WinDivert.dll" > nul
echo Downloading WinDivert.dll..... Completed!
echo Start downloading WinDivert64.sys from Zapret GitHub repo (may be antivirus false or not-a-virus warning).....
bitsadmin /transfer progdwnl https://github.com/bol-van/zapret/blob/master/binaries/win64/zapret-winws/WinDivert64.sys?raw=true "%~dp0\WinDivert64.sys" > nul
echo Downloading WinDivert64.sys..... Completed!
echo Start downloading winws.exe from Zapret GitHub repo (may be antivirus false warning).....
bitsadmin /transfer progdwnl https://github.com/bol-van/zapret/blob/master/binaries/win64/zapret-winws/winws.exe?raw=true "%~dp0\winws.exe" > nul
echo Downloading winws.exe..... Completed!
)
echo.
echo Downloading completed
echo Starting Zapret.....
ping 1.1.1.1 > nul
goto :ZapretStart

:ZapretStart
start "zapret: http,https,quic,discord" /min "%~dp0winws.exe" ^
--wf-tcp=80,443 --wf-udp=443,50000-50090 ^
--filter-tcp=80 --hostlist="%~dp0netrogat.txt" --new ^
--filter-tcp=443 --hostlist="%~dp0netrogat.txt" --new ^
--filter-udp=443 --hostlist="%~dp0russia-youtubeQ.txt" --dpi-desync=fake,udplen --dpi-desync-udplen-increment=10 --dpi-desync-udplen-pattern=0xDEADBEEF --dpi-desync-fake-quic="%~dp0quic_pl_by_ori.bin" --dpi-desync-cutoff=n2 --dpi-desync-repeats=2 --new ^
--filter-tcp=443 --hostlist="%~dp0russia-youtubeGV.txt" --dpi-desync=split --dpi-desync-split-pos=1 --dpi-desync-fooling=badseq --dpi-desync-repeats=10  --dpi-desync-autottl --new ^
--filter-tcp=443 --hostlist="%~dp0russia-youtube.txt" --dpi-desync=fake,split2 --dpi-desync-split-seqovl=2 --dpi-desync-split-pos=2 --dpi-desync-fake-tls="%~dp0tls_clienthello_www_google_com.bin" --dpi-desync-autottl --new ^
--filter-tcp=80 --hostlist="%~dp0russia-blacklist.txt" --dpi-desync=fake,split2 --dpi-desync-fooling=md5sig --dpi-desync-autottl --new ^
--filter-tcp=443 --hostlist="%~dp0russia-blacklist.txt" --hostlist="%~dp0myhostlist.txt" --dpi-desync=fake,split2 --dpi-desync-split-seqovl=3 --dpi-desync-split-tls=sniext --dpi-desync-fake-tls="%~dp0tls_clienthello_www_google_com.bin" --dpi-desync-autottl --new ^
--filter-udp=443 --hostlist="%~dp0russia-discord.txt" --dpi-desync=fake --dpi-desync-fake-quic="%~dp0quic_pl_by_ori.bin" --dpi-desync-cutoff=n2 --dpi-desync-repeats=7 --new ^
--filter-udp=50000-50090 --dpi-desync=fake --dpi-desync-any-protocol --dpi-desync-cutoff=d2 --dpi-desync-fake-quic="%~dp0quic_pl_by_ori.bin" --new ^
--filter-tcp=443 --hostlist="%~dp0russia-discord.txt" --dpi-desync=split2 --dpi-desync-split-seqovl=2 --dpi-desync-split-pos=3 --dpi-desync-autottl --new ^
--filter-tcp=443 --hostlist-auto="%~dp0autohostlist.txt" --hostlist-exclude="%~dp0netrogat.txt" --dpi-desync=split --dpi-desync-split-pos=1 --dpi-desync-fooling=badseq --dpi-desync-repeats=10 --dpi-desync-autottl

exit /b
